/*
 * Copyright (c) 2002, 2010, Oracle and/or its affiliates. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

Solaris uses the gtk unlock dialog program originally written by
Ximian & Wipro, in order to provide a dialog box that works with
the GNOME accessibility framework.   This was done as a fork of
the original xscreensaver because the maintainer would not allow
use of a toolkit in the lock dialog - he has since softened his
stance a bit, but this has not been presented to him to see if it
meets his requirements as spelled out at:
        http://www.jwz.org/xscreensaver/toolkits.html

This patch also contains a fixes for:

Sun bug 6541240
       Screen saver will lock user out of the system if they have no
       password set

Sun bug 5077993/GNOME Bug 147639:
        Gok cant automatically UI grab screensaver preferences
        http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=5077993
        http://bugzilla.gnome.org/show_bug.cgi?id=147639

Sun bug 5083155:
        Unable to unlock screen when running dual-head magnification
        http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=5083155

Sun bug 5059445:
        screen kb and screen reader support
        http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=5059445

Sun bug 5039878:
        "Password:" field should be focused / have flashing caret
        http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=5039878

Sun bug 6461887:
        GNOME screen lock does not prevent access to other applications
         via 'alt-tab'

Sun bug 6736157:
        [A11Y] Security problem when desktop a11y support is turned on.

Sun bug 6573182:
        after applying patch 120094-11 (or later), xscreensaver coredump
        http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=6573182
---
 config.h.in           |    3 +
 configure.in          |   23 +-
 driver/Makefile.in    |   59 +++-
 driver/auth.h         |    4 +
 driver/demo-Gtk.c     |   18 +
 driver/dialog-data.h  |  122 ++++++
 driver/lock-Gtk.c     |  956 ++++++++++++++++++++++++++++++++++++++++++++
 driver/lock.c         | 1069 ++++++++++++++++++++++++++++++++++++++++++++-----
 driver/passwd-pam.c   |  207 +++++++++-
 driver/passwd.c       |    1 +
 driver/setuid.c       |    5 +-
 driver/subprocs.c     |   35 ++-
 driver/timers.c       |  114 ++++++-
 driver/types.h        |   18 +
 driver/windows.c      |   21 +-
 driver/xscreensaver.c |  131 ++++++-
 driver/xscreensaver.h |    6 +
 17 files changed, 2654 insertions(+), 135 deletions(-)
 create mode 100644 driver/dialog-data.h
 create mode 100644 driver/lock-Gtk.c

diff --git xscreensaver-5.12/config.h.in xscreensaver-5.12/config.h.in
--- xscreensaver-5.12/config.h.in
+++ xscreensaver-5.12/config.h.in
@@ -405,6 +405,9 @@
    make use of this if it is available. */
 #undef HAVE_XPM
 
+/* Define this to build the external lock dialog */
+#undef HAVE_XSCREENSAVER_LOCK
+
 /* Define this if you have the X Shared Memory Extension. */
 #undef HAVE_XSHM_EXTENSION
 
diff --git xscreensaver-5.12/configure.in xscreensaver-5.12/configure.in
--- xscreensaver-5.12/configure.in
+++ xscreensaver-5.12/configure.in
@@ -2527,6 +2527,8 @@ if test "$with_gtk" = yes; then
   pkg_check_version        libglade-2.0  1.99.0
   pkg_check_version      gdk-pixbuf-2.0  2.0.0
   pkg_check_version gdk-pixbuf-xlib-2.0  2.0.0
+  pkg_check_version           gconf-2.0  2.6.1
+  pkg_check_version  libloginhelper-1.0  1.0
   have_gtk="$ok"
 
   if test "$have_gtk" = no; then
@@ -2542,6 +2544,9 @@ if test "$with_gtk" = yes; then
   fi
 
   if test "$have_gtk" = yes; then
+#--- Begin SUNW addition
+    AC_DEFINE(HAVE_XSCREENSAVER_LOCK,[],[Define this to build the external lock dialog])
+#--- End SUNW addition
     AC_CACHE_CHECK([for Gtk includes], ac_cv_gtk_config_cflags,
                    [ac_cv_gtk_config_cflags=`$pkg_config --cflags $pkgs`])
     AC_CACHE_CHECK([for Gtk libs], ac_cv_gtk_config_libs,
@@ -3626,6 +3631,16 @@ if test "$have_gtk" = yes; then
   ALL_DEMO_PROGRAMS="$PREFERRED_DEMO_PROGRAM $ALL_DEMO_PROGRAMS"
 fi
 
+#--- Begin SUNW addition
+PREFERRED_LOCK_PROGRAM=
+ALL_LOCK_PROGRAMS=
+LOCK_PROGRAM=
+if test "$have_gtk" = yes; then
+  PREFERRED_LOCK_PROGRAM=xscreensaver-lock-Gtk
+  ALL_LOCK_PROGRAMS="$PREFERRED_LOCK_PROGRAM $ALL_LOCK_PROGRAMS"
+  LOCK_PROGRAM=xscreensaver-lock
+fi
+#--- End SUNW addition
 
 if test "$have_kerberos" = yes; then
   PASSWD_SRCS="$PASSWD_SRCS \$(KERBEROS_SRCS)"
@@ -3765,6 +3780,11 @@ AC_SUBST(INCLUDES)
 
 AC_SUBST(PREFERRED_DEMO_PROGRAM)
 AC_SUBST(ALL_DEMO_PROGRAMS)
+#--- Begin SUNW addition
+AC_SUBST(PREFERRED_LOCK_PROGRAM)
+AC_SUBST(ALL_LOCK_PROGRAMS)
+AC_SUBST(LOCK_PROGRAM)
+#--- End SUNW addition
 AC_SUBST(SAVER_LIBS)
 AC_SUBST(MOTIF_LIBS)
 AC_SUBST(GTK_LIBS)
@@ -4244,7 +4264,8 @@ HACK_CONF_DIR=`echo "${HACK_CONF_DIR}" | sed 's@/$@@;s@//*@/@g'`
 
 
 # Sanity check the hackdir
-for bad_choice in xscreensaver xscreensaver-demo xscreensaver-command ; do
+# SUNW addition: added xscreensaver-lock to list on next line
+for bad_choice in xscreensaver xscreensaver-demo xscreensaver-command xscreensaver-lock ; do
   if test "${HACKDIR}" = "${bindir}/${bad_choice}" ; then
     echo ""
     AC_MSG_ERROR([\"--with-hackdir=${bindir}/${bad_choice}\" won't work.
diff --git xscreensaver-5.12/driver/auth.h xscreensaver-5.12/driver/auth.h
--- xscreensaver-5.12/driver/auth.h
+++ xscreensaver-5.12/driver/auth.h
@@ -51,4 +51,8 @@ xss_authenticate(saver_info *si, Bool verbose_p);
 void
 auth_finished_cb (saver_info *si);
 
+#ifdef HAVE_XSCREENSAVER_LOCK
+extern int write_to_child (saver_info* si, const char* cmd, const char *msg);
+#endif
+
 #endif
diff --git xscreensaver-5.12/driver/demo-Gtk.c xscreensaver-5.12/driver/demo-Gtk.c
--- xscreensaver-5.12/driver/demo-Gtk.c
+++ xscreensaver-5.12/driver/demo-Gtk.c
@@ -98,6 +98,8 @@
 # define G_MODULE_EXPORT /**/
 #endif /* !HAVE_GTK2 */
 
+#include <gconf/gconf-client.h>
+
 #if defined(DEFAULT_ICONDIR) && !defined(GLADE_DIR)
 # define GLADE_DIR DEFAULT_ICONDIR
 #endif
@@ -5006,6 +5008,22 @@ main (int argc, char **argv)
   load_init_file (dpy, p);
   initialize_sort_map (s);
 
+  /* Bug 147639: Gok cant automatically UI grab screensaver preferences */
+  {
+    GConfClient *client = gconf_client_get_default ();
+
+#define KEY "/desktop/gnome/interface/accessibility"
+
+    /* check if accessibilty mode is enabled */
+    if (gconf_client_get_bool (client, KEY, NULL))
+      {
+	/* GTK Accessibility Module initialized */
+	const char *modulesptr = g_getenv ("GTK_MODULES");
+	if (!modulesptr || (modulesptr [0] == '\0'))
+	  putenv ("GTK_MODULES=gail:atk-bridge");
+      }
+  }
+
   /* Now that Xt has been initialized, and the resources have been read,
      we can set our `progname' variable to something more in line with
      reality.
diff --git xscreensaver-5.12/driver/dialog-data.h xscreensaver-5.12/driver/dialog-data.h
new file mode 100644
--- /dev/null
+++ xscreensaver-5.12/driver/dialog-data.h
@@ -0,0 +1,122 @@
+/* xscreensaver, Copyright (c) 1993-2008 Jamie Zawinski <jwz@jwz.org>
+ *
+ * Permission to use, copy, modify, distribute, and sell this software and its
+ * documentation for any purpose is hereby granted without fee, provided that
+ * the above copyright notice appear in all copies and that both that
+ * copyright notice and this permission notice appear in supporting
+ * documentation.  No representations are made about the suitability of this
+ * software for any purpose.  It is provided "as is" without express or
+ * implied warranty.
+ */
+
+#ifndef __DIALOG_DATA_H__
+#define __DIALOG_DATA_H__
+
+#include <stdio.h>
+#include "types.h"
+#include "mlstring.h"
+
+struct passwd_dialog_data {
+
+  saver_screen_info *prompt_screen;
+  int previous_mouse_x, previous_mouse_y;
+
+  char typed_passwd [80];
+
+  XtIntervalId timer;
+  int i_beam;
+
+  float ratio;
+  Position x, y;
+  Dimension width;
+  Dimension height;
+  Dimension border_width;
+
+  Bool echo_input;
+  Bool show_stars_p; /* "I regret that I have but one asterisk for my country."
+                        -- Nathan Hale, 1776. */
+
+  char *heading_label;
+  char *body_label;
+  char *user_label;
+  mlstring *info_label;
+  /* The entry field shall only be displayed if prompt_label is not NULL */
+  mlstring *prompt_label;
+  char *date_label;
+  char *passwd_string;
+  Bool passwd_changed_p; /* Whether the user entry field needs redrawing */
+  Bool caps_p;           /* Whether we saw a keypress with caps-lock on */
+  char *unlock_label;
+  char *login_label;
+  char *uname_label;
+
+  Bool show_uname_p;
+
+#ifndef HAVE_XSCREENSAVER_LOCK
+  XFontStruct *heading_font;
+  XFontStruct *body_font;
+  XFontStruct *label_font;
+  XFontStruct *passwd_font;
+  XFontStruct *date_font;
+  XFontStruct *button_font;
+  XFontStruct *uname_font;
+
+  Pixel foreground;
+  Pixel background;
+  Pixel passwd_foreground;
+  Pixel passwd_background;
+  Pixel thermo_foreground;
+  Pixel thermo_background;
+  Pixel shadow_top;
+  Pixel shadow_bottom;
+  Pixel button_foreground;
+  Pixel button_background;
+
+  Dimension preferred_logo_width, logo_width;
+  Dimension preferred_logo_height, logo_height;
+  Dimension thermo_width;
+  Dimension internal_border;
+  Dimension shadow_width;
+
+  Dimension passwd_field_x, passwd_field_y;
+  Dimension passwd_field_width, passwd_field_height;
+
+  Dimension unlock_button_x, unlock_button_y;
+  Dimension unlock_button_width, unlock_button_height;
+
+  Dimension login_button_x, login_button_y;
+  Dimension login_button_width, login_button_height;
+
+  Dimension thermo_field_x, thermo_field_y;
+  Dimension thermo_field_height;
+
+  Pixmap logo_pixmap;
+  Pixmap logo_clipmask;
+  int logo_npixels;
+  unsigned long *logo_pixels;
+#endif /* ! HAVE_XSCREENSAVER_LOCK */
+
+  Cursor passwd_cursor;
+  Bool unlock_button_down_p;
+  Bool login_button_down_p;
+  Bool login_button_p;
+  Bool login_button_enabled_p;
+  Bool button_state_changed_p; /* Refers to both buttons */
+
+  Pixmap save_under;
+  Pixmap user_entry_pixmap;
+
+#ifdef HAVE_XSCREENSAVER_LOCK
+  /* extern passwd dialog stuff */
+  XtInputId stdout_input_id;
+  int       stdin_fd;    /* child's stdin - parent writes to this */
+  int       stdout_fd;   /* child's stdout - parent reads from this */
+  FILE     *stdin_file;  /* child's stdin - parent writes to this */
+  FILE     *stdout_file; /* child's stdout - parent reads from this */
+  Bool      got_windowid;
+  Bool      got_passwd;
+#endif
+};
+
+#endif /* __DIALOG_DATA_H__ */
+
